import java.io.IOException;
import java.io.InputStream;
import java.util.Date;
import java.util.Enumeration;
import java.util.Vector;

import javax.microedition.io.Connector;

import com.nttdocomo.io.HttpConnection;
import com.nttdocomo.net.URLEncoder;
import com.nttdocomo.util.Phone;


public class CommControl {
	protected static CommControl commControl;
	protected String sourceUrl;
    protected String userId;
	protected CommControl(String sourceUrl) {
		this.sourceUrl = sourceUrl;
    	userId = Phone.getProperty(Phone.USER_ID);
	}
	public static void init(String sourceUrl) {
		commControl = new CommControl(sourceUrl);
	}
	public static CommControl getInstance() {
		return commControl;
	}
	protected String getImageUrl(String id) {
		return sourceUrl + "images/" + id;
	}
	public void updateEntries(Vector entries) {
		StringBuffer url = new StringBuffer(sourceUrl);
		url.append("itwitter.php?icc=" + userId);
		if (!entries.isEmpty()) {
			url.append("&had=");
			Enumeration e = entries.elements();
			while (e.hasMoreElements()) {
				Entry entry = (Entry) e.nextElement();
				url.append(entry.getId());
				if (e.hasMoreElements()) {
					url.append(",");
				}
			}
		}
		Vector v = getEntries(url.toString());
		if (v == null || v.size() == 0) {
			// XVȂ
			return;
		}
		int n = 0;
		try {
			n = Integer.parseInt((String) v.elementAt(0));
		} catch (Exception e) {
			if (v.size() > 0) {
				throw new RuntimeException((String)v.elementAt(0));
			} else {
				throw new RuntimeException("empty response");
			}
		}
		if (n < 0) {
			// G[
			if (v.size() > 1) {
				throw new RuntimeException((String)v.elementAt(1));
			} else {
				throw new RuntimeException((String)v.elementAt(0));
			}
		}
		if (n == 0 || v.size() < n * 5 + 1) {
			// XVȂ or f[^ُ
			return;
		}
		for (int i = 0; i < n; i++) {
			Entry e = new Entry();
			e.setId((String)v.elementAt(i * 5 + 1));
			e.setText((String)v.elementAt(i * 5 + 2));
			e.setCreatedAt(new Date(Long.parseLong((String)v.elementAt(i * 5 + 3)) * 1000));
			e.setUserId((String)v.elementAt(i * 5 + 4));
			String screenName = (String)v.elementAt(i * 5 + 5);
			User.getUser(e.getUserId(), screenName, getImageUrl(e.getUserId()));
			boolean needInsert = true;
			for (int j = 0; j < entries.size(); j++) {
				if (j > Entry.ENTRY_MAX) {
					needInsert = false;
					break;
				}
				Entry t = (Entry) entries.elementAt(j);
				if (e.getCreatedAt().getTime() > t.getCreatedAt().getTime()) {
					entries.insertElementAt(e, j);
					needInsert = false;
					break;
				}
			}
			if (needInsert) {
				entries.addElement(e);
			}
		}
		int over = entries.size() - Entry.ENTRY_MAX;
		if (over > 0) {
			for (int i = 0; i < over; i++) {
				entries.removeElementAt(Entry.ENTRY_MAX);
			}
		}
		for (int i = 0; i < entries.size(); i++) {
			Entry e = (Entry) entries.elementAt(i);
			User.getUser(e.getUserId());
		}
		User.flush();
	}
	public Vector getEntries(String url) {
		try {
			HttpConnection conn = (HttpConnection) Connector.open(url, Connector.READ, true);
			conn.setRequestMethod("GET");
			conn.connect();
			InputStream in = conn.openInputStream();
			byte data[] = new byte[(int) conn.getLength()];
			in.read(data);
			in.close();
			conn.close();
			
			return parseLine(data);
		} catch (IOException e) {
			// s
			e.printStackTrace();
			return null;
		}
		
	}
	public static Vector parseLine(byte data[]) {
		try {
		String str = new String(data, "utf-8");
		Vector v = new Vector();
		int index, oldindex = 0;
		while (true) {
			index = str.indexOf('\n', oldindex);
			if (index == -1) {
				v.addElement(str.substring(oldindex));
				break;
			}
			v.addElement(str.substring(oldindex, index));
			oldindex = index + 1;
		}
		return v;
		} catch (Exception e) {
			return new Vector();
		}
	}
	public byte[] getImage(String url) {
		HttpConnection conn = null;
		byte data[] = null;
		try {
			conn = (HttpConnection) Connector.open(url, Connector.READ, true);
			conn.setRequestMethod("GET");
			conn.connect();
			InputStream in = conn.openInputStream();
			data = new byte[(int) conn.getLength()];
			in.read(data);
			in.close();
		} catch (IOException e) {
			// 
			System.out.println(url);
		}
		if (conn != null) {
			try {
				conn.close();
			} catch (Exception e) {
				
			}
		}
		return data;
	}
	public void twit(String text) {
		try {
			StringBuffer url = new StringBuffer(sourceUrl);
			url.append("itwitter.php?icc=" + userId + "&twit=");
			url.append(URLEncoder.encode(text));
			HttpConnection conn = (HttpConnection) Connector.open(url.toString(), Connector.READ, true);
			conn.setRequestMethod("GET");
			conn.connect();
			conn.close();
			
		} catch (IOException e) {
			// s
			e.printStackTrace();
		}
	}
}
