import java.util.Calendar;
import java.util.Date;
import java.util.Vector;

import com.nttdocomo.lang.MemoryManager;
import com.nttdocomo.ui.AnchorButton;
import com.nttdocomo.ui.Button;
import com.nttdocomo.ui.Component;
import com.nttdocomo.ui.ComponentListener;
import com.nttdocomo.ui.Dialog;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.ImageLabel;
import com.nttdocomo.ui.KeyListener;
import com.nttdocomo.ui.MApplication;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.Panel;
import com.nttdocomo.ui.SoftKeyListener;
import com.nttdocomo.ui.TextBox;
import com.nttdocomo.util.Timer;
import com.nttdocomo.util.TimerListener;

/**
 * MainPanel
 * 
 */
public class MainPanel extends Panel implements SoftKeyListener, KeyListener, ComponentListener, TimerListener {
	Button dummy = new Button();
    Button button = new Button("XV");
    AnchorButton statusLine = new AnchorButton();
    TextBox input = new TextBox("", 30, 1, TextBox.DISPLAY_ANY);
    ImageLabel ibutton[];
    AnchorButton text[];
    MediaImage mi;
    protected int textWidth;
    protected boolean busy;
    protected boolean autoUpdate = true;
    protected boolean mmode = false;
    protected boolean amode;
    protected Timer timer;
    public static int VIEW_MAX = 10;
    MainPanel(boolean mmode) {
    	this.mmode = mmode;
    	amode = !mmode;
        setTitle("iTwitterMobile");
        setSoftLabel(SOFT_KEY_1, "I");
        setSoftLabel(SOFT_KEY_2, "蓮");
        setSoftKeyListener(this);
        setLayoutManager(null);
        setKeyListener(this);
        setBackground(0x9ae4e8);
        dummy.setSize(0, 0);
        dummy.setVisible(false);
        add(dummy);
        add(input);
        add(button);
        add(statusLine);
        input.setLocation(0, 0);
        input.setInputSize(140);
        button.setLocation(input.getWidth() + 5, 0);
        statusLine.setLocation(0, input.getHeight() + 10);
        setComponentListener(this);
        ibutton = new ImageLabel[VIEW_MAX];
        text = new AnchorButton[VIEW_MAX];
        textWidth = Display.getWidth() - 24 - 10;
        for (int i = 0; i < ibutton.length; i++) {
        	ibutton[i] = new ImageLabel();
        	text[i] = new AnchorButton();
        	text[i].setEnabled(false);
        	add(ibutton[i]);
        	add(text[i]);
        	ibutton[i].setVisible(false);
        	text[i].setVisible(false);
        }
        redisplay();
        timer = new Timer();
        timer.setTime(2000);
        //timer.setRepeat(true);
        timer.setListener((TimerListener)this);
        timer.start();
    }
    public void setAMode(boolean mode) {
    	amode = mode;
        setSoftLabel(SOFT_KEY_1, mmode ? "Ҏ" : "I");
        redisplay();
    }
    public void softKeyPressed(int softKey) {
    }
    
    public void softKeyReleased(int softKey) {
        if (softKey == SOFT_KEY_1) {
        	if (mmode) {
        		amode = false;
        		redisplay();
        		((MApplication)IApplication.getCurrentApp()).deactivate();
        	} else {
        		IApplication.getCurrentApp().terminate();
        	}
        } else if (softKey == SOFT_KEY_2) {
        	autoUpdate = !autoUpdate;
            setSoftLabel(SOFT_KEY_2, autoUpdate ? "蓮" : "");
        }
    }
    
    public void keyPressed(Panel panel, int key) {
    }
    
    public void keyReleased(Panel panel, int key) {
        switch (key) {
            case Display.KEY_1:
                break;
            case Display.KEY_2:
                break;
            case Display.KEY_3:
                break;
            default:
                break;
        }
    }
    
    public void componentAction(Component source, int type, int param) {
        if (source == button) {
            if (type == BUTTON_PRESSED) {
            	if (input.getText().length() > 0) {
                	synchronized (this) {
                		if (busy) {
                			return;
                		}
                		button.setEnabled(false);
                		busy = true;
                	}
            		CommControl.getInstance().twit(input.getText());
            		input.setText("");
            		button.setEnabled(true);
            		busy = false;
            		return;
            	}
            	updateEntries();
            }
        }
    }
    
    public void updateEntries() {
    	synchronized (this) {
    		if (busy) {
    			return;
    		}
    		button.setEnabled(false);
    		busy = true;
    	}
    	Vector entries = Entry.getEntries();
    	try  {
    		CommControl.getInstance().updateEntries(entries);
    	} catch (Exception e) {
    		Dialog d = new Dialog(Dialog.DIALOG_ERROR, "G[");
    		d.setText(e.getMessage());
    		d.show();
        	busy = false;
    		button.setEnabled(true);
    		return;
    	}
    	redisplay();
    	busy = false;
		button.setEnabled(true);
		//input.requestFocus();
    }
    protected void redisplay() {
    	dummy.setVisible(!amode);
    	if (!amode) {
    		dummy.requestFocus();
    	}
        input.setVisible(amode);
        button.setVisible(amode);
    	Vector entries = Entry.getEntries();
    	int y = amode ? input.getHeight() + 5 : 2;
    	
    	for (int i = 0; i < entries.size(); i++) {
    		if (i >= VIEW_MAX) {
    			break;
    		}
    		Entry e = (Entry) entries.elementAt(i);
    		User u = User.getUser(e.getUserId());
    		if (u == null) {
    			continue;
    		}
    		ibutton[i].setLocation(0, y);
    		if (u.getImage() != null) {
    			ibutton[i].setImage(u.getImage().getImage());
        		ibutton[i].setVisible(true);
    		} else {
    			ibutton[i].setVisible(false);
    		}
    		String str1 = e.getText();
    		String str2 = "by " + u.getScreenName() + " at " + formatDate(e.getCreatedAt());
    		int height = getTextHeight(str1) + getTextHeight(str2);
    		text[i].setText(str1 + "\n" + str2);
    		text[i].setLocation(30, y);
    		text[i].setSize(textWidth, height);
    		text[i].setVisible(true);
    		y += height + 2;
    	}
    	updateStatus();
    	statusLine.setLocation(0, y + 5);
    	if (entries.size() < VIEW_MAX) {
    		for (int i = entries.size(); i < VIEW_MAX; i++) {
    			ibutton[i].setVisible(false);
    			text[i].setVisible(false);
    		}
    	}
    
    }
    public static String formatDate(Date date) {
    	Calendar c = Calendar.getInstance();
    	c.setTime(date);
    	StringBuffer str = new StringBuffer();
    	str.append(c.get(Calendar.YEAR));
    	str.append("/");
    	str.append(c.get(Calendar.MONTH));
    	str.append("/");
    	str.append(c.get(Calendar.DATE));
    	str.append(" ");
    	str.append(c.get(Calendar.HOUR_OF_DAY));
    	str.append(":");
    	str.append(c.get(Calendar.MINUTE));
    	str.append(":");
    	str.append(c.get(Calendar.SECOND));
    	
    	return str.toString();
    }
    protected void updateStatus() {
    	MemoryManager mm = MemoryManager.getMemoryManager();
    	long freemem[] = mm.freeMemory();
    	long totalmem[] = mm.totalMemory();
    	StringBuffer str = new StringBuffer();
    	for (int i = 0; i < freemem.length; i++) {
    		str.append((freemem[i] / 1024) + "kb/" + (totalmem[i] / 1024) + "kb ");
    	}
    	statusLine.setText(str.toString());
    }
    protected int getTextHeight(String str) {
    	Font f = Font.getDefaultFont();
    	int off = 0;
    	int len = str.length();
    	int noff;
    	int y = 0;
    	int h = f.getHeight() + 3;
    	while (len > 0) {
    		noff = f.getLineBreak(str, off, len, textWidth);
    		len -= (noff - off);
    		off = noff;
    		y += h;
    	}
    	return y;
    }
    
    public void timerExpired(Timer source) {
    	if (autoUpdate) {
    		updateEntries();
    	}
        timer.setTime(60000);
        timer.start();
    }
    public void awake() {
    	try {
    		timer.start();
    	} catch (Exception e) {
    		// 
    	}
    }
    
}

